#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf mac-fdisk_0.1.orig.tar.gz
    cd mac-fdisk-0.1.orig
    gunzip -c ../mac-fdisk_0.1-16.diff.gz | patch -p1 -b
    make pdisk
    strip -R .note -R .comment pdisk
    mkdir -p ../mac-fdisk/sbin
    cp pdisk ../mac-fdisk/sbin/mac-fdisk
    cd ..
    rm -rf mac-fdisk-0.1.orig
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
